import { Chain, Network } from "@wormhole-foundation/sdk-base";
import { SignedTx, TxHash } from "./types";
import { UnsignedTransaction } from "./unsignedTransaction";
export type Signer<N extends Network = Network, C extends Chain = Chain> = SignOnlySigner<N, C> | SignAndSendSigner<N, C>;
export declare function isSigner(thing: any): thing is Signer<Network, Chain>;
interface SignerBase<C extends Chain> {
    chain(): C;
    address(): string;
}
export interface SignOnlySigner<N extends Network, C extends Chain> extends SignerBase<C> {
    sign(tx: UnsignedTransaction<N, C>[]): Promise<SignedTx[]>;
}
export declare function isSignOnlySigner(thing: any): thing is SignOnlySigner<Network, Chain>;
export interface SignAndSendSigner<N extends Network, C extends Chain> extends SignerBase<C> {
    signAndSend(tx: UnsignedTransaction<N, C>[]): Promise<TxHash[]>;
}
export declare function isSignAndSendSigner(thing: any): thing is SignAndSendSigner<Network, Chain>;
export type NativeSigner = any;
export declare abstract class PlatformNativeSigner<NS extends NativeSigner, N extends Network = Network, C extends Chain = Chain> {
    protected _chain: C;
    protected _address: string;
    protected _signer: NS;
    constructor(_chain: C, _address: string, _signer: NS);
    unwrap(): NS;
    abstract chain(): C;
    abstract address(): string;
    abstract sign(tx: UnsignedTransaction<N, C>[]): Promise<SignedTx[]>;
}
export declare function isNativeSigner(thing: any): thing is PlatformNativeSigner<any>;
export {};
//# sourceMappingURL=signer.d.ts.map